Loading...
Searching...
No Matches
Dune::GridGlue::Intersection< P0, P1, I, O > Class Template Reference

The intersection of two entities of the two patches of a GridGlue. More...

`#include <dune/grid-glue/adapter/intersection.hh>`

Inheritance diagram for Dune::GridGlue::Intersection< P0, P1, I, O >:

## Public Types

typedef IntersectionTraits< P0, P1, I, O > | Traits
typedef Traits::GridGlue | GridGlue
typedef Traits::IntersectionData | IntersectionData
typedef Traits::InsideGridView | InsideGridView
typedef Traits::InsideLocalGeometry | InsideLocalGeometry
typedef Traits::OutsideGridView | OutsideGridView
typedef Traits::OutsideLocalGeometry | OutsideLocalGeometry
typedef Traits::OutsideGeometry | OutsideGeometry
typedef Traits::Geometry | Geometry
typedef Traits::ctype | ctype
typedef InsideGridView::Traits::template Codim< 0 >::Entity | InsideEntity
typedef OutsideGridView::Traits::template Codim< 0 >::Entity | OutsideEntity
typedef Traits::LocalCoordinate | LocalCoordinate
typedef Traits::GlobalCoordinate | GlobalCoordinate

## Public Member Functions

| Intersection (const GridGlue GridGlue *glue, const IntersectionData *i)
| Constructor for a given Dataset.
InsideEntity | inside (unsigned int parentId=0) const
| Return element on the inside of this intersection.
OutsideEntity | outside (unsigned int parentId=0) const
| Return element on the outside of this intersection.
bool | conforming () const
| Return true if intersection is conforming.
const InsideLocalGeometry & | geometryInInside (unsigned int parentId=0) const
| Geometric information about this intersection in local coordinates of the inside() element.
const OutsideLocalGeometry & | geometryInOutside (unsigned int parentId=0) const
| Geometric information about this intersection in local coordinates of the outside() element.
const Geometry & | geometry () const
| Geometric information about this intersection as part of the inside grid.
const OutsideGeometry & | geometryOutside () const
| Geometric information about this intersection as part of the outside grid.
Dune::GeometryType | type () const
| Type of reference element for this intersection.
bool | self () const
| For parallel computations: Return true if inside() entity exists locally.
size_t | neighbor (unsigned int g=0) const
| Return number of embeddings into local grid0 (grid1) entities.
int | indexInInside (unsigned int parentId=0) const
| Local number of codim 1 entity in the inside() Entity where intersection is contained in.
int | indexInOutside (unsigned int parentId=0) const
| Local number of codim 1 entity in outside() Entity where intersection is contained in.
GlobalCoordinate | outerNormal (const LocalCoordinate &local) const
| Return an outer normal (length not necessarily 1).
GlobalCoordinate | unitOuterNormal (const LocalCoordinate &local) const
| Return a unit outer normal.
GlobalCoordinate | integrationOuterNormal (const LocalCoordinate &local) const
| Return an outer normal with the length of the integration element.
GlobalCoordinate | centerUnitOuterNormal () const
| Unit outer normal at the center of the intersection.
Intersection< P0, P1, O, I > | flip () const
| Return a copy of the intersection with inside and outside switched.

## Static Public Attributes

static constexpr auto | coorddim = Traits::coorddim
| dimension of the world space of the intersection
static constexpr auto | mydim = Traits::mydim
| dimension of the intersection
static constexpr int | insidePatch = Traits::insidePatch
| inside patch
static constexpr int | outsidePatch = Traits::outsidePatch
| outside patch

## Friends

class | IntersectionIndexSet< P0, P1 >

## Detailed Description

template<typename P0, typename P1, int I, int O>
class Dune::GridGlue::Intersection< P0, P1, I, O >

The intersection of two entities of the two patches of a GridGlue.

## Member Typedef Documentation

## ctype

template<typename P0, typename P1, int I, int O>

typedef Traits::ctype Dune::GridGlue::Intersection< P0, P1, I, O >::ctype

## Geometry

template<typename P0, typename P1, int I, int O>

typedef Traits::Geometry Dune::GridGlue::Intersection< P0, P1, I, O >::Geometry

## GlobalCoordinate

template<typename P0, typename P1, int I, int O>

typedef Traits::GlobalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::GlobalCoordinate

## GridGlue

template<typename P0, typename P1, int I, int O>

typedef Traits::GridGlue Dune::GridGlue::Intersection< P0, P1, I, O >::GridGlue

## InsideEntity

template<typename P0, typename P1, int I, int O>

typedef InsideGridView::Traits::template Codim<0>::Entity Dune::GridGlue::Intersection< P0, P1, I, O >::InsideEntity

## InsideGridView

template<typename P0, typename P1, int I, int O>

typedef Traits::InsideGridView Dune::GridGlue::Intersection< P0, P1, I, O >::InsideGridView

## InsideLocalGeometry

template<typename P0, typename P1, int I, int O>

typedef Traits::InsideLocalGeometry Dune::GridGlue::Intersection< P0, P1, I, O >::InsideLocalGeometry

## IntersectionData

template<typename P0, typename P1, int I, int O>

typedef Traits::IntersectionData Dune::GridGlue::Intersection< P0, P1, I, O >::IntersectionData

## LocalCoordinate

template<typename P0, typename P1, int I, int O>

typedef Traits::LocalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::LocalCoordinate

## OutsideEntity

template<typename P0, typename P1, int I, int O>

typedef OutsideGridView::Traits::template Codim<0>::Entity Dune::GridGlue::Intersection< P0, P1, I, O >::OutsideEntity

## OutsideGeometry

template<typename P0, typename P1, int I, int O>

typedef Traits::OutsideGeometry Dune::GridGlue::Intersection< P0, P1, I, O >::OutsideGeometry

## OutsideGridView

template<typename P0, typename P1, int I, int O>

typedef Traits::OutsideGridView Dune::GridGlue::Intersection< P0, P1, I, O >::OutsideGridView

## OutsideLocalGeometry

template<typename P0, typename P1, int I, int O>

typedef Traits::OutsideLocalGeometry Dune::GridGlue::Intersection< P0, P1, I, O >::OutsideLocalGeometry

## Traits

template<typename P0, typename P1, int I, int O>

typedef IntersectionTraits<P0,P1,I,O> Dune::GridGlue::Intersection< P0, P1, I, O >::Traits

## Constructor & Destructor Documentation

## Intersection()

template<typename P0, typename P1, int I, int O>

Dune::GridGlue::Intersection< P0, P1, I, O >::Intersection | ( | const GridGlue GridGlue * | glue,
|  | const IntersectionData * | i )

inline

Constructor for a given Dataset.

## Member Function Documentation

## centerUnitOuterNormal()

template<typename P0, typename P1, int I, int O>

GlobalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::centerUnitOuterNormal | ( |  | ) | const

inline

Unit outer normal at the center of the intersection.

The outer normal is given with respect to the geometry().

## conforming()

template<typename P0, typename P1, int I, int O>

bool Dune::GridGlue::Intersection< P0, P1, I, O >::conforming | ( |  | ) | const

inline

Return true if intersection is conforming.

## flip()

template<typename P0, typename P1, int I, int O>

Intersection< P0, P1, O, I > Dune::GridGlue::Intersection< P0, P1, I, O >::flip | ( |  | ) | const

inline

Return a copy of the intersection with inside and outside switched.

## geometry()

template<typename P0, typename P1, int I, int O>

const Geometry & Dune::GridGlue::Intersection< P0, P1, I, O >::geometry | ( |  | ) | const

inline

Geometric information about this intersection as part of the inside grid.

This is the same geometry as the application of the first embedding into the "inside" entity and then this entities global geometry.

## geometryInInside()

template<typename P0, typename P1, int I, int O>

const InsideLocalGeometry & Dune::GridGlue::Intersection< P0, P1, I, O >::geometryInInside | ( | unsigned int | parentId = 0 | ) | const

inline

Geometric information about this intersection in local coordinates of the inside() element.

## geometryInOutside()

template<typename P0, typename P1, int I, int O>

const OutsideLocalGeometry & Dune::GridGlue::Intersection< P0, P1, I, O >::geometryInOutside | ( | unsigned int | parentId = 0 | ) | const

inline

Geometric information about this intersection in local coordinates of the outside() element.

## geometryOutside()

template<typename P0, typename P1, int I, int O>

const OutsideGeometry & Dune::GridGlue::Intersection< P0, P1, I, O >::geometryOutside | ( |  | ) | const

inline

Geometric information about this intersection as part of the outside grid.

This is the same geometry as the application of the first embedding into the "outside" entity and then this entities global geometry.

## indexInInside()

template<typename P0, typename P1, int I, int O>

int Dune::GridGlue::Intersection< P0, P1, I, O >::indexInInside | ( | unsigned int | parentId = 0 | ) | const

inline

Local number of codim 1 entity in the inside() Entity where intersection is contained in.

## indexInOutside()

template<typename P0, typename P1, int I, int O>

int Dune::GridGlue::Intersection< P0, P1, I, O >::indexInOutside | ( | unsigned int | parentId = 0 | ) | const

inline

Local number of codim 1 entity in outside() Entity where intersection is contained in.

## inside()

template<typename P0, typename P1, int I, int O>

InsideEntity Dune::GridGlue::Intersection< P0, P1, I, O >::inside | ( | unsigned int | parentId = 0 | ) | const

inline

Return element on the inside of this intersection.

## integrationOuterNormal()

template<typename P0, typename P1, int I, int O>

GlobalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::integrationOuterNormal | ( | const LocalCoordinate & | local | ) | const

inline

Return an outer normal with the length of the integration element.

The outer normal is given with respect to the geometry().

## neighbor()

template<typename P0, typename P1, int I, int O>

size_t Dune::GridGlue::Intersection< P0, P1, I, O >::neighbor | ( | unsigned int | g = 0 | ) | const

inline

Return number of embeddings into local grid0 (grid1) entities.

## outerNormal()

template<typename P0, typename P1, int I, int O>

GlobalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::outerNormal | ( | const LocalCoordinate & | local | ) | const

inline

Return an outer normal (length not necessarily 1).

The outer normal is given with respect to the geometry().

## outside()

template<typename P0, typename P1, int I, int O>

OutsideEntity Dune::GridGlue::Intersection< P0, P1, I, O >::outside | ( | unsigned int | parentId = 0 | ) | const

inline

Return element on the outside of this intersection.

## self()

template<typename P0, typename P1, int I, int O>

bool Dune::GridGlue::Intersection< P0, P1, I, O >::self | ( |  | ) | const

inline

For parallel computations: Return true if inside() entity exists locally.

## type()

template<typename P0, typename P1, int I, int O>

Dune::GeometryType Dune::GridGlue::Intersection< P0, P1, I, O >::type | ( |  | ) | const

inline

Type of reference element for this intersection.

## unitOuterNormal()

template<typename P0, typename P1, int I, int O>

GlobalCoordinate Dune::GridGlue::Intersection< P0, P1, I, O >::unitOuterNormal | ( | const LocalCoordinate & | local | ) | const

inline

Return a unit outer normal.

The outer normal is given with respect to the geometry().

## Friends And Related Symbol Documentation

## IntersectionIndexSet< P0, P1 >

template<typename P0, typename P1, int I, int O>

friend class IntersectionIndexSet< P0, P1 >

friend

## Member Data Documentation

## coorddim

template<typename P0, typename P1, int I, int O>

auto Dune::GridGlue::Intersection< P0, P1, I, O >::coorddim = Traits::coorddim

static constexpr

dimension of the world space of the intersection

## insidePatch

template<typename P0, typename P1, int I, int O>

int Dune::GridGlue::Intersection< P0, P1, I, O >::insidePatch = Traits::insidePatch

static constexpr

inside patch

## mydim

template<typename P0, typename P1, int I, int O>

auto Dune::GridGlue::Intersection< P0, P1, I, O >::mydim = Traits::mydim

static constexpr

dimension of the intersection

## outsidePatch

template<typename P0, typename P1, int I, int O>

int Dune::GridGlue::Intersection< P0, P1, I, O >::outsidePatch = Traits::outsidePatch

static constexpr

outside patch

The documentation for this class was generated from the following files:

- gridglue.hh
- intersection.hh